module.exports = function () {
    String.prototype.toJSON = function (isthrow = false) {
        if (this.length == 0 && isthrow) throw new Error('空字符串错误');
        let json_data = '';
        try {
            json_data = eval('(' + this + ')');
            if (typeof json_data != 'object') {
                json_data = '';
                throw '转换结果不是object';
            }
        } catch (error) {
            if (isthrow) throw new Error(this + '不是json格式的字符串');
        }
        return json_data;
    };
    // ( 1 ) String.contains()
    // String.prototype.contains = function (text) {
    //     if (text == '') return true;
    //     else if (text == null) return false;
    //     else return this.indexOf(text) !== -1;
    // };

    // ( 2 ) String.count()
    String.prototype.count = function (text) {
        if (this.contains(text))
            return this.split(text).length - 1;
        else
            return 0;
    };

    // ( 3 ) String.capitalize()
    String.prototype.capitalize = function () {
        if (this == '') return this;
        else return this.charAt(0).toUpperCase() + this.slice(1).toLowerCase();
    };

    // ( 4 ) String.trim()
    // String.prototype.trim = function () {
    //     return this.replace(/^\s+|\s+$/g, '');
    // };

    // // ( 5 ) String.leftTrim()
    // String.prototype.leftTrim = function () {
    //     return this.replace(/^\s+/, '');
    // };

    // // ( 6 ) String.rightTrim()
    // String.prototype.rightTrim = function () {
    //     return this.replace(/\s+$/, '');
    // };

    // ( 7 ) String.clear()
    String.prototype.clear = function () {
        return this.replace(/^\s+|\s+$/g, '').replace(/\s+/g, ' ');
    };

    // ( 8 ) String.startsWith()
    // String.prototype.startsWith = function (start) {
    //     if (start == '') return true;
    //     else if (start == null || start.length > this.length) return false;
    //     else return this.substring(0, start.length) == start;
    // };

    // // ( 9 ) String.endsWith()
    // String.prototype.endsWith = function (end) {
    //     if (end == '') return true;
    //     else if (end == null || end.length > this.length) return false;
    //     else return this.indexOf(end, this.length - end.length) !== -1;
    // };

    // ( 10 ) String.insert()
    // String.prototype.insert = function (text, at) {
    //     if (at == null || at > this.length)
    //         at = this.length;
    //     else if (at < 0)
    //         at = 0;

    //     return this.substring(0, at) + text + this.substring(at);
    // };


    Date.prototype.add = function (milliseconds) {
        var m = this.getTime() + milliseconds;
        return new Date(m);
    };
    Date.prototype.addSeconds = function (second) {
        return this.add(second * 1000);
    };
    Date.prototype.addMinutes = function (minute) {
        return this.addSeconds(minute * 60);
    };
    Date.prototype.addHours = function (hour) {
        return this.addMinutes(60 * hour);
    };

    Date.prototype.addDays = function (day) {
        return this.addHours(day * 24);
    };

    Date.isLeepYear = function (year) {
        return (year % 4 == 0 && year % 100 != 0);
    };

    Date.daysInMonth = function (year, month) {
        if (month == 2) {
            if (year % 4 == 0 && year % 100 != 0)
                return 29;
            else
                return 28;
        }
        else if ((month <= 7 && month % 2 == 1) || (month > 7 && month % 2 == 0))
            return 31;
        else
            return 30;
    };

    Date.prototype.addMonth = function () {
        var m = this.getMonth();
        if (m == 11) return new Date(this.getFullYear() + 1, 0, this.getDate(), this.getHours(), this.getMinutes(), this.getSeconds());

        var daysInNextMonth = Date.daysInMonth(this.getFullYear(), this.getMonth() + 1);
        var day = this.getDate();
        if (day > daysInNextMonth) {
            day = daysInNextMonth;
        }
        return new Date(this.getFullYear(), this.getMonth() + 1, day, this.getHours(), this.getMinutes(), this.getSeconds());
    };

    Date.prototype.subMonth = function () {
        var m = this.getMonth();
        if (m == 0) return new Date(this.getFullYear() - 1, 11, this.getDate(), this.getHours(), this.getMinutes(), this.getSeconds());
        var day = this.getDate();
        var daysInPreviousMonth = Date.daysInMonth(this.getFullYear(), this.getMonth());
        if (day > daysInPreviousMonth) {
            day = daysInPreviousMonth;
        }
        return new Date(this.getFullYear(), this.getMonth() - 1, day, this.getHours(), this.getMinutes(), this.getSeconds());
    };

    Date.prototype.addMonths = function (addMonth) {
        var result = false;
        if (addMonth > 0) {
            while (addMonth > 0) {
                result = this.addMonth();
                addMonth--;
            }
        } else if (addMonth < 0) {
            while (addMonth < 0) {
                result = this.subMonth();
                addMonth++;
            }
        } else {
            result = this;
        }
        return result;
    };

    Date.prototype.addYears = function (year) {
        return new Date(this.getFullYear() + year, this.getMonth(), this.getDate(), this.getHours(), this.getMinutes(), this.getSeconds());
    };

    Date.prototype.format = function (format) {
        var o = {
            'M+': this.getMonth() + 1, //month
            'd+': this.getDate(),    //day
            'h+': this.getHours(),   //hour
            'm+': this.getMinutes(), //minute
            's+': this.getSeconds(), //second
            'q+': Math.floor((this.getMonth() + 3) / 3),  //quarter
            'S': this.getMilliseconds() //millisecond
        };
        if (/(y+)/.test(format)) format = format.replace(RegExp.$1,
            (this.getFullYear() + '').substr(4 - RegExp.$1.length));
        for (var k in o) if (new RegExp('(' + k + ')').test(format))
            format = format.replace(RegExp.$1,
                RegExp.$1.length == 1 ? o[k] :
                    ('00' + o[k]).substr(('' + o[k]).length));
        return format;
    };

    Date.prototype.firstdate = function () {
        var year = this.getFullYear();
        var month = this.getMonth() + 1;
        return (new Date(year + '/' + month + '/01'));
    };

    Date.prototype.lastdate = function () {
        return this.firstdate().addMonth().addDays(-1);
    };

    Date.prototype.yearfirstdate = function () {
        var year = this.getFullYear();
        var month = 1;
        return (new Date(year + '/' + month + '/01'));
    };

    Date.prototype.yearlastdate = function () {
        return this.yearfirstdate().addYears(1).addDays(-1);
    };
};