const log4js = require('log4js');
const path = require('path');

//创建3个类别的log记录器
//serverlogger 主程序的日志
//httplogger   http通讯的日志,包括静态文件和api文件  可以统计访问量等
//apifile      api接口日志
/*
    config: {  //ERROR>WARN>INFO>DEBUG
        serverlog: 'ERROR',
        httplog: 'ERROR',
        apilog: 'DEBUG',
        wxlog: 'ERROR',
        applog: 'ERROR',
    },
*/
module.exports = function (config, app) {
    log4js.configure({
        appenders: {
            ruleConsole: { type: 'console' },
            serverfile: { type: 'dateFile', filename: path.join(__dirname, '../www/log/server.log'), pattern: '.yyyy-MM-dd', maxLogSize: 10485760, daysToKeep: 7, keepFileExt: true },
            httpfile: { type: 'dateFile', filename: path.join(__dirname, '../www/log/http.log'), pattern: '.yyyy-MM-dd', maxLogSize: 10485760, daysToKeep: 7, keepFileExt: true },
            apifile: { type: 'dateFile', filename: path.join(__dirname, '../www/log/api.log'), pattern: '.yyyy-MM-dd', maxLogSize: 10485760, daysToKeep: 7, keepFileExt: true },
            wxfile: { type: 'dateFile', filename: path.join(__dirname, '../www/log/weixin.log'), pattern: '.yyyy-MM-dd', maxLogSize: 10485760, daysToKeep: 7, keepFileExt: true },
            appfile: { type: 'dateFile', filename: path.join(__dirname, '../www/log/app.log'), pattern: '.yyyy-MM-dd', maxLogSize: 10485760, daysToKeep: 7, keepFileExt: true }
        },
        categories: {
            default: { appenders: ['ruleConsole', 'serverfile'], level: 'debug' },
            serverlog: { appenders: ['ruleConsole', 'serverfile'], level: config.serverlog || 'debug' },
            httplog: { appenders: ['httpfile'], level: config.httplog || 'debug' },
            apilog: { appenders: ['ruleConsole','apifile'], level: config.apilog || 'debug' },
            wxlog: { appenders: ['ruleConsole', 'wxfile'], level: config.wxlog || 'debug' },
            applog: { appenders: ['ruleConsole', 'appfile'], level: config.applog || 'debug' },
        }
    });
    app.serverlogger = log4js.getLogger('serverlog');
    app.httplogger = log4js.getLogger('httplog');
    app.apilogger = log4js.getLogger('apilog');
    app.wxlogger = log4js.getLogger('wxlog');
    app.applogger = log4js.getLogger('applog');
};