const koaRoute = require('koa-router');
const multer = require('koa-multer');
const fs = require('fs');
const path = require('path');
const db = require('./orm/ormsubcon');
const wxSDK = require('./weixin/wxSDK');
const config = require('../config');
const rp = require('request-promise-native');

module.exports = function () {
    let RootRouter = new koaRoute();
    let router = new koaRoute();

    var storage = multer.diskStorage({
        //文件保存路径  
        destination: function (req, file, cb) {
            cb(null, path.join(__dirname, '../', 'uploads/'));
        },
        //修改文件名称  
        filename: function (req, file, cb) {
            var fileFormat = (file.originalname).split('.');
            cb(null, Date.now() + '.' + fileFormat[fileFormat.length - 1]);
        }
    });
    //加载配置  
    var upload = multer({ storage: storage });
    //路由    FIXME:file_data和上传中的那么对应
    router.post('/', upload.single('file_data'), async function (ctx) {
        var filepath = ctx.req.file.path;
        {
            if (!ctx.session || !ctx.session.user) throw '请登录';
            let i_公司编号 = ctx.session.user.I_公司编号;

            let 公司 = await (await db.listtable('s_公司表')).where('I_公司编号=:gsbh', { gsbh: i_公司编号 }).getOne();
            if (!公司) throw '公司(' + i_公司编号 + ')不存在!';
            if (!公司.J_公众号授权) throw '请先进行微信公众号授权!';
            if (!公司.J_公众号授权.authorization_info) throw '请先进行微信公众号授权!';
            let 公众号授权 = 公司.J_公众号授权.authorization_info;

            let wxsdk = new wxSDK(config.WXConfg, global.app.connection);
            var token = await wxsdk.刷新公众号token(公众号授权.authorizer_appid, 公众号授权.authorizer_refresh_token);
        }
        var opts = {
            method: 'POST',
            url: 'https://api.weixin.qq.com/cgi-bin/media/uploadimg?access_token=' + token,
            json: true,
            formData: {
                media: fs.createReadStream(filepath)
            },
        };
        let resultjson = await rp.post(opts);
        fs.unlinkSync(filepath);//删除临时文件
        resultjson.result = '成功';
        ctx.body = resultjson;
    });

    RootRouter.use('/upload', router.routes(), router.allowedMethods());
    return RootRouter;
};